Combines values from arrays. [:running:] [:vhs:] [:package:] [:moon:]
> Alternatives: [zip], [zipLongest].<br>
> This is part of package [extra-array].

[extra-array]: https://www.npmjs.com/package/extra-array

```javascript
array.zip(xs, [fn], [ths]);
// xs:  arrays
// fn:  map function (vs, i, xs)
// ths: this argument
```

```javascript
const array = require('extra-array');

var x = [1, 2, 3];
var y = [4, 5, 6];
array.zip([x, y]);
// [ [ 1, 4 ], [ 2, 5 ], [ 3, 6 ] ]

array.zip([x, y], ([a, b]) => a + b);
// [ 5, 7, 9 ]
```

### references

- [Data.List.zipWith: Haskell](http://hackage.haskell.org/package/base-4.12.0.0/docs/Data-List.html#v:zipWith)
- [List-Extra.zip: elm](https://package.elm-lang.org/packages/elm-community/list-extra/7.1.0/List-Extra#zip)
- [_.zipWith: lodash](https://lodash.com/docs/4.17.15#zipWith)
- [zip: Python](https://www.programiz.com/python-programming/methods/built-in/zip)
- [zip: Ruby](https://apidock.com/ruby/Array/zip)

[:running:]: https://npm.runkit.com/@extra-array/zip
[:package:]: https://www.npmjs.com/package/@extra-array/zip
[:moon:]: https://www.npmjs.com/package/@extra-array/zip.min
[:vhs:]: https://asciinema.org/a/319471
